program receipt;
{$APPTYPE CONSOLE}
uses
  winomeg, sysutils, dialogs, windows;

type
  MyPChar = array [0..255] of char;

var
  TmpString : MyPChar;
  NrPortu, Timeout : longword;
  blad : longword;
  Wartosc : longword;
  Suma : longword;
  PlikWejsciowy, PlikWyjsciowy : Text;
  NazwaPlikuWej, NazwaPlikuWyj  : string;

  LiniaZPliku : String;
  Nazwa : MyPChar;
  Sprzed : MyPChar;
  Stawka, Cena, Ilosc : MyPChar;
  StawkaI : longword;
  CenaI, IloscI : longword;
  Rabat : MyPChar;
  Jedn : MyPChar;
  Komunikat : MyPChar;
  KomunikatI : longword;
  MP : MyPChar;
  MPI : longword;
  Predkosc : longword;
  FreeLines : longword;
  Numer : longword;
  TylkoOtwarcieSzuflady : boolean;
  inbuf,outbuf : tbufferofbytes;
  Tmp : ShortString;
  Fiscal : longword;
  rr1,mm1,dd1, rr2, mm2, dd2 : longword;
  PierwszyRaz : boolean;
  Stawki : array [1..7] of longword;
  IleStawek : longword;
  Licznik : byte;
  Hour, Minute : byte;
  Time : ShortString;
  DebugMode : longword;

function WyciagnijZLiniiArgument( nrarg : byte;linia : String) : MyPChar;
var
  Licznik, LDod, Licznik3 : byte;
  tmps : MyPChar;
begin
  for Licznik:=0 to 255 do
     tmps[Licznik]:=chr(0);
  Licznik := 1;
  LDod := 1;
  while ((LDod<=Length(linia)) and (Licznik<nrarg)) do
    begin
      while (LDod<=Length(Linia)) and (linia[LDod]<>#9) do
        inc(LDod);
      inc(LDod);
      inc(Licznik);
    end;
  Licznik3:=0;
  while ((LDod<=Length(Linia)) and (Linia[LDod]<>#9)) do
    begin
      tmps[Licznik3]:=Linia[LDod];
      inc(LDod);
      inc(Licznik3);
    end;
  WyciagnijZLiniiArgument := tmps;
end;

procedure ObsluzBlad(Blad : word;ZakonczProgram : boolean; Funkcja,Komunikat : Ansistring);
var
  TmpString : MyPChar;
begin
  if Komunikat='' then
    begin
      pErrMessage(Blad,TmpString);
      writeln(PlikWyjsciowy, IntToStr(Blad)+chr($09)+TmpString+chr($09)+Funkcja);
    end
  else
    writeln(PlikWyjsciowy, IntToStr(Blad)+chr($09)+Komunikat);
  if ZakonczProgram then
    begin
      CommunicationEnd;
      Close(PlikWyjsciowy);
      Close(PlikWejsciowy);
      Halt(Blad);
    end;
end;

begin
  TylkoOtwarcieSzuflady := True;
  PierwszyRaz := True;

  if ParamStr(2)<>'' then
    NazwaPlikuWyj := ParamStr(2)
  else
    NazwaPlikuWyj:='raport.txt';

  try
    AssignFile(PlikWyjsciowy, NazwaPlikuWyj);
    Rewrite(PlikWyjsciowy);
  except
    Halt(1);
  end;

  writeln(PlikWyjsciowy,'#',ParamStr(0)+#9+DateTimeToStr(Now));
  pDllVersion(TmpString);
  writeln(PlikWyjsciowy,'#','Biblioteka ElzabDr.Dll wersja'+#9+TmpString);
  writeln(PlikWyjsciowy,'#');
  if ParamCount<1 then
    begin
      writeln(PlikWyjsciowy,'501'+chr($09)+'Brak nazwy pliku wejsciowego');
      Close(PlikWyjsciowy);
      Halt(1);
    end;
  NazwaPlikuWej:=ParamStr(1);
  try
    AssignFile(PlikWejsciowy, NazwaPlikuWej);
    Reset(PlikWejsciowy);
  except
    writeln(PlikWyjsciowy,'%Nie otwarto pliku wejsciowego');
    Close(PlikWyjsciowy);
    Halt(1);
  end;

  repeat
    readln(PlikWejsciowy,LiniaZPliku);
  until not ((length(LiniaZPliku)>0) and (LiniaZPliku[1] = ';'));

  try
    NrPortu:=StrToInt(WyciagnijZLiniiArgument(1,LiniaZPliku));
  except
    ObsluzBlad(500,True,'','Bledny format pliku wejsciowego');
  end;

  try
    Predkosc:=StrToInt(WyciagnijZLiniiArgument(2,LiniaZPliku));
  except
    Predkosc:=9600;
  end;
  try
    Timeout:=StrToInt(WyciagnijZLiniiArgument(3,LiniaZPliku));
  except
    Timeout:=5;
  end;

  try
    DebugMode:=StrToInt(WyciagnijZLiniiArgument(4,LiniaZPliku));
  except
    DebugMode := 0;
  end;

  if DebugMode = 1 then
    SetDebugMode
  else
    ClearDebugMode;

  if DebugMode=2 then
    OptimizeTransmission();


  Blad:=CommunicationInit(NrPortu,Predkosc,Timeout);
  if Blad<>0 then
    ObsluzBlad(Blad,True, 'CommunicationInit('+IntToStr(NrPortu)+')','');
  try
    while not eof (PlikWejsciowy) do
      begin
        readln(PlikWejsciowy, LiniaZPliku);
        Wartosc:=0;
        if Length(LiniaZPliku)=0 then
          break;
        Rabat:=WyciagnijZLiniiArgument(2,LiniaZPliku);
        Sprzed:=WyciagnijZLiniiArgument(1,LiniaZPliku);
        Nazwa:= WyciagnijZLiniiArgument(2,LiniaZPliku);
        Stawka:=WyciagnijZLiniiArgument(3,LiniaZPliku);
        Ilosc:=WyciagnijZLiniiArgument(4,LiniaZPliku);
        Cena:=WyciagnijZLiniiArgument(5,LiniaZPliku);
        Jedn:=WyciagnijZLiniiArgument(6,LiniaZPliku);
        MP := WyciagnijZLiniiArgument(7,LiniaZPliku);
        Komunikat := WyciagnijZLiniiArgument(8,LiniaZPliku);
        if Komunikat = '' then
          Komunikat := '0';
        if Jedn='' then
          Jedn:='szt.';
        if MP = '' then
          MPI:=0
        else
          try
            MPI:=StrToInt(MP);
          except
            writeln(PlikWyjsciowy, '%Bledny format pliku wejsciowego');
            Close(PlikWejsciowy);
            Close(PlikWyjsciowy);
            Halt(1);
          end;

        case Sprzed[0] of
        'K'     : ShowMessage(String(Rabat)+chr($0D)+chr($0D)+'Nacinij ENTER');
        'O'     : begin
                    Blad := DailyReport(StrToint(Rabat));
                    if Blad<>0 then
                      ObsluzBlad(Blad, True, 'DailyReport','');
                    writeln(PlikWyjsciowy,'0'+chr($09)+'Program zakonczony bezblednie');
                    Blad:=CommunicationEnd;
                    if Blad<>0 then
                      ObsluzBlad(Blad,True,'CommunicationEnd','');
                    CloseFile(PlikWejsciowy);
                    CloseFile(PlikWyjsciowy);
                    Halt(1); //program
                  //raport dobowy
                  end;
        'X'     : begin
                    try
                       Hour := StrToInt(WyciagnijZLiniiArgument(2, LiniaZPliku));
                       Minute := StrToInt(WyciagnijZLiniiArgument(3, LiniaZPliku));
                    except
                       ObsluzBlad(500,True,'','Bledny format pliku wejsciowego');
                    end;
                    Blad := ChangeTime(Hour, Minute);
                    if Blad<>0 then
                      ObsluzBlad(Blad,True,'ChangeTime','');
                    writeln(PlikWyjsciowy,'0'+chr($09)+'Program zakonczony bezblednie');
                    Blad:=CommunicationEnd;
                    if Blad<>0 then
                      ObsluzBlad(Blad,True,'CommunicationEnd','');
                    CloseFile(PlikWejsciowy);
                    CloseFile(PlikWyjsciowy);
                    Halt(1); //program
                  //przestawianie zegara
                  end;
        'E'     : begin
                    Blad := PrintResume();
                    if Blad<>0 then
                      ObsluzBlad(Blad, True, 'PrintResume','');
                    writeln(PlikWyjsciowy,'0'+chr($09)+'Program zakonczony bezblednie');
                    Blad:=CommunicationEnd;
                    if Blad<>0 then
                      ObsluzBlad(Blad,True,'CommunicationEnd','');
                    CloseFile(PlikWejsciowy);
                    CloseFile(PlikWyjsciowy);
                    Halt(1); //program
                  //wznowienie wydruku
                  end;

         'V'     : begin
                     Blad := ReadVAT(IleStawek, Stawki[1],Stawki[2],Stawki[3],
                                   Stawki[4],Stawki[5],Stawki[6],Stawki[7]);
                     if Blad<>0 then
                       ObsluzBlad(Blad, True, 'ReadVAT','');
                     Blad := sReadUniqueNumber(Tmp);
                     if Blad<>0 then
                       ObsluzBlad(Blad, True, 'ReadUniqueNumber','');

                     Blad := sReadClock(Time);
                     if Blad<>0 then
                       ObsluzBlad(Blad, True, 'ReadClock','');
                     if length(Time)>8 then
                       Time[9] := chr($09);

                     writeln(PlikWyjsciowy,'0'+chr($09)+'Program zakonczony bezblednie');

                     for Licznik:=1 to IleStawek do
                       begin
                         if Stawki[Licznik]=10000 then
                           write(PlikWyjsciowy,'ZWOLNIONA')
                         else
                           if Stawki[Licznik]=25500 then
                             write(PlikWyjsciowy,'REZERWA')
                           else
                             write(PlikWyjsciowy,IntToStr(Stawki[Licznik]));
                         if Licznik<IleStawek then
                           write(PlikWyjsciowy, chr($09))
                         else
                           writeln(PlikWyjsciowy);
                       end;
                     writeln(PlikWyjsciowy, Tmp);
                     writeln(PlikWyjsciowy, Time);
                     Blad:=CommunicationEnd;
                     if Blad<>0 then
                       ObsluzBlad(Blad,True,'CommunicationEnd','');
                     CloseFile(PlikWejsciowy);
                     CloseFile(PlikWyjsciowy);
                     Halt(1); //program
                     //odczyt stawek podatkowych
                 end;
       'P'     : begin
                   try
                     Fiscal := StrToInt(WyciagnijZLiniiArgument(2, LiniaZPliku));
                     rr1 :=StrToInt(WyciagnijZLiniiArgument(3, LiniaZPliku));
                     mm1 :=StrToInt(WyciagnijZLiniiArgument(4, LiniaZPliku));
                     dd1 :=StrToInt(WyciagnijZLiniiArgument(5, LiniaZPliku));
                     rr2 :=StrToInt(WyciagnijZLiniiArgument(6, LiniaZPliku));
                     mm2 :=StrToInt(WyciagnijZLiniiArgument(7, LiniaZPliku));
                     dd2 :=StrToInt(WyciagnijZLiniiArgument(8, LiniaZPliku));
                   except
                      ObsluzBlad(500,True,'','Bledny format pliku wejsciowego');
                   end;
                   Blad := PeriodReport(Fiscal, rr1, mm1, dd1, rr2, mm2, dd2);
                   if Blad<>0 then
                     ObsluzBlad(Blad, True, 'PeriodReport','');
                   writeln(PlikWyjsciowy,'0'+chr($09)+'Program zakonczony bezblednie');
                   Blad:=CommunicationEnd;
                   if Blad<>0 then
                    ObsluzBlad(Blad,True,'CommunicationEnd','');
                   CloseFile(PlikWejsciowy);
                   CloseFile(PlikWyjsciowy);
                   Halt(1); //program
                  //raport okresowy
                 end;
       'R'     : break;
       '+','-' : begin
                  TylkoOtwarcieSzuflady := False;
                  try
                   StawkaI:=StrToInt64(Stawka);
                   CenaI:=StrToInt64(Cena);
                   IloscI:=StrToInt64(Ilosc);
                  except
                    ObsluzBlad(500,True,'','%Bledny format pliku wejsciowego');
                  end;
                  if Sprzed[0]='+' then
                   begin
                    for Licznik:=0 to 27 do
                      if ord(Nazwa[Licznik])<$20 then
                       Nazwa[Licznik]:=' ';
                    if PierwszyRaz then
                      begin
                        ErasePayments;
                        EraseLines;
                        PierwszyRaz := False;
                        Blad := ReceiptBegin;
                        if Blad<>0 then
                          ObsluzBlad(Blad,True,'ReceiptBegin','');
                      end;
                    try
                      KomunikatI := StrToInt(Komunikat);
                    except
                      ObsluzBlad(500,True,'','Bledny format pliku wejsciowego');
                    end;
                    Blad:=pReceiptItem(1,Nazwa,StawkaI,KomunikatI,IloscI,MPI,Jedn,CenaI,Wartosc);
                    if Blad<>0 then
                     begin
                      pErrMessage(Blad,TmpString);
                      ObsluzBlad(Blad,True,'ReceiptItem (sprzedaz)',TmpString);
                     end;
                   end
                  else
                   begin
                    try
                      KomunikatI := StrToInt(Komunikat);
                    except
                      ObsluzBlad(500,True,'','Bledny format pliku wejsciowego');
                    end;
                    for Licznik:=0 to 27 do
                      if ord(Nazwa[Licznik])<$20 then
                       Nazwa[Licznik]:=' ';
                    Blad:=pReceiptItem(0,Nazwa,StawkaI,KomunikatI,IloscI,MPI,Jedn,CenaI,Wartosc);
                    if Blad<>0 then
                     begin
                      ObsluzBlad(Blad,True,'ReceiptItem (korekta)','');
                     end;
                   end
                 end;   //+ -
       'S'     : begin
                 TylkoOtwarcieSzuflady := False;
                    if PierwszyRaz then
                      begin
                        PierwszyRaz := False;
                        Blad := ReceiptBegin;
                        if Blad<>0 then
                          ObsluzBlad(Blad,True,'ReceiptBegin','');
                      end;
                  Blad:=PackageItem(0,word(StrToInt(Nazwa)),word(StrToInt64(Stawka)),longword(StrToInt64(Ilosc)));
                  if Blad<>0 then
                   ObsluzBlad(Blad,False,'PackageItem (sprzedaz)','');
                 end; //S
       's'     : begin
                 TylkoOtwarcieSzuflady := False;
                    if PierwszyRaz then
                      begin
                        PierwszyRaz := False;
                        Blad := ReceiptBegin;
                        if Blad<>0 then
                          ObsluzBlad(Blad,True,'ReceiptBegin','');
                      end;
                  Blad:=PackageItem(2,word(StrToInt(Nazwa)),word(StrToInt64(Stawka)),longword(StrToInt64(Ilosc)));
                  if Blad<>0 then
                   ObsluzBlad(Blad,False,'PackageItem (anulowanie sprzedazy)','');
                 end; //s
       'Z'     : begin
                  TylkoOtwarcieSzuflady := False;
                    if PierwszyRaz then
                      begin
                        PierwszyRaz := False;
                        Blad := ReceiptBegin;
                        if Blad<>0 then
                          ObsluzBlad(Blad,True,'ReceiptBegin','');
                      end;
                  Blad:=PackageItem(1,word(StrToInt(Nazwa)),word(StrToInt64(Stawka)),longword(StrToInt64(Ilosc)));
                  if Blad<>0 then
                   begin
                    pErrMessage(Blad,TmpString);
                    writeln(PlikWyjsciowy, '%PackageItem (przyjecie): ',TmpString);
                   end;
                 end; //Z
       'z'     : begin
                 TylkoOtwarcieSzuflady := False;
                    if PierwszyRaz then
                      begin
                        PierwszyRaz := False;
                        Blad := ReceiptBegin;
                        if Blad<>0 then
                          ObsluzBlad(Blad,True,'ReceiptBegin','');
                      end;
                  Blad:=PackageItem(3,word(StrToInt(Nazwa)),word(StrToInt64(Stawka)),longword(StrToInt64(Ilosc)));
                  if Blad<>0 then
                   ObsluzBlad(Blad,False,'PackageItem (anulowanie zwrotu)','');
                 end; //s
      'T'    : begin
                  TylkoOtwarcieSzuflady := False;
                    if PierwszyRaz then
                      begin
                        PierwszyRaz := False;
                        Blad := ReceiptBegin;
                        if Blad<>0 then
                          ObsluzBlad(Blad,True,'ReceiptBegin','');
                      end;
                  Blad:=PrintSubtotal;
                  if Blad<>0 then
                   begin
                    pErrMessage(Blad,TmpString);
                    writeln(PlikWyjsciowy, '%PrintSubtotal: ',TmpString);
                   end;
                 end; //SUB
      'D'      : begin
                  try
                   Blad:=OpenDrawer(StrToInt(WyciagnijZLiniiArgument(2,LiniaZPliku)));
                  except
                   ObsluzBlad(500,True,'','Bledny format pliku wejsciowego');
                  end;
                  if Blad<>0 then
                   begin
                    pErrMessage(Blad,TmpString);
                    writeln(PlikWyjsciowy, '%OpenDrawer: ',TmpString);
                   end;
                 end; //D
      'L'      : begin
                   try
                     Blad:=pFillLines(StrToInt(Nazwa),Stawka,FreeLines);
                     if Blad<>0 then
                       ObsluzBlad(Blad,False,'FillLines','');
                   except
                     ObsluzBlad(500,True,'','Bledny format pliku wejsciowego');
                   end;
                 end;
      'W'      : begin
                   try
                    if MP='' then
                      MP := '1';
                     if Nazwa[0] = '1' then
                         Blad:=pCurrencyPayment1(Stawka, Ilosc, StrToInt64(Cena), StrToInt64(Jedn), StrToInt(MP))
                     else
                       if Nazwa[0] = '2' then
                         Blad:= pCurrencyPayment2(StrToInt64(Stawka), StrToInt64(Ilosc), StrToInt64(Cena), StrToInt64(Jedn), StrToInt(MP));

                     if Blad<>0 then
                       ObsluzBlad(Blad,False,'pCurrencyPayment','');
                   except
                     ObsluzBlad(500,True,'','Bledny format pliku wejsciowego');
                   end;

                 end;
      'C'      : begin  //patnosci
                   try
                     Blad:=pFillPayment(StrToInt(Nazwa), Stawka, StrToInt64(Ilosc), StrToInt64(Cena));
                     if Blad<>0 then
                       ObsluzBlad(Blad,False,'pSendPayment','');
                   except
                     ObsluzBlad(500,True,'','Bledny format pliku wejsciowego');
                   end;
                 end;
      'I'      : begin  //rabat
                   try
                     Blad:=DiscountOrSurcharge(1, StrToInt64(Nazwa));
                     if Blad<>0 then
                       ObsluzBlad(Blad,False,'DiscountOrSurcharge','');
                   except
                     ObsluzBlad(500,True,'','Bledny format pliku wejsciowego');
                   end;
                 end;
      'H'      : begin  //narzut
                   try
                     Blad:=DiscountOrSurcharge(0, StrToInt64(Nazwa));
                     if Blad<>0 then
                       ObsluzBlad(Blad,False,'DiscountOrSurcharge','');
                   except
                     ObsluzBlad(500,True,'','Bledny format pliku wejsciowego');
                   end;
                 end;
      ';'       : continue //komentarz
      else   ObsluzBlad(500,True,'','Bledny format pliku wejsciowego');
      end; //case
   end; //while
except
  ObsluzBlad(500,True,'','Bledny format pliku wejsciowego');
end;
   if Sprzed[0]='R' then
   begin
    try
      StawkaI := StrToInt64(Stawka);
    except
      StawkaI := 0;
    end;
    try
      Blad:=ReceiptEndEx(StrToInt64(Rabat), StawkaI);
    except
       ObsluzBlad(500,True,'','Bledny format pliku wejsciowego');
    end;
   end
   else
    if TylkoOtwarcieSzuflady then
      begin
         writeln(PlikWyjsciowy,'0');
         writeln(PlikWyjsciowy,'0'+chr($09)+'Program zakonczony bezblednie');
      end
    else
      begin
          Blad:=ReceiptEnd(0);
      end;
          if Blad=0 then
            begin
             Blad:=ReceiptNumber(Numer);
             if Blad=0 then
              begin
               writeln(PlikWyjsciowy,'0'+chr($09)+'NrParagonu'+chr($09)+IntToStr(Numer));
               writeln(PlikWyjsciowy,'0'+chr($09)+'Program zakonczony bezblednie');
              end
             else
               ObsluzBlad(Blad,False,'ReceiptNumber','');
            end
          else
             ObsluzBlad(Blad,True,'ReceiptEnd','');
    Blad:=CommunicationEnd;
    if Blad<>0 then
      ObsluzBlad(Blad,True,'CommunicationEnd','');
    CloseFile(PlikWejsciowy);
    CloseFile(PlikWyjsciowy);
end.





